import Model
import View



def main():
    m=Model.Model()
    thisView = View.View()
    exit=False
    currentMenu=0

    #Compruebo si tengo datos guardados en disco
    try:
        fh = open('DataDetails.pckl', 'r')
        thisView.setHayDatos(True)
    except FileNotFoundError:
        thisView.setHayDatos(False)





    while exit == False:
        # Menu Principal
        if currentMenu == 0:
            opt = thisView.MainMenu()
            if isValid(opt,'menu'):
                opt = int(opt)
                currentMenu = opt #Menu Codificar Datos

                if opt == 4: # Salir
                    exit = True
                if opt== 2: #Ver detalle
                    if(thisView.getHayDatos()):
                        m.showDataDetails()
                        #m.loadDatafromfile()
                        currentMenu = 0  # Menu Clasifición de Datos
                    else:
                        thisView.noData()
                        currentMenu = 1
                if opt == 3:
                    if thisView.getHayDatos():
                        currentMenu = 3  # Clasifición de datos
                    else:
                        thisView.noData()
                        currentMenu = 1
            else:
                thisView.Error()


        # Menu Codificar Datos
        if currentMenu==1:
            opt = thisView.ShowMenuCod()
            if isValid(opt,'menu'):
                opt = int(opt)
                if opt == 1:
                    # Codificar datos (valores por defecto)"
                    m.mapperAdvanced()
                    m.generateTrainTest()
                    thisView.setHayDatos(True)
                    currentMenu = 3
                elif opt == 2:
                    # Codificar datos con valores introducidos por pantalla
                    MAX,MIN,MAXP,MINP,cw,cp = thisView.AskValues()
                    MIN, MAX, MINP, MAXP = float(MIN),float(MAX),float(MINP),float(MAXP)
                    if isRangeValid(MIN, MAX) == False:
                        thisView.Error("Rango MIN - MAX no valido")
                    elif isRangeValid(MINP, MAXP) == False:
                        thisView.Error("Rango MINP - MAXP no valido")

                    else:
                        cw, cp = int(cw), int(cp)
                        if isValid(cw,'cw'):
                            if isValid(cp,'cw'):
                                m.mapperAdvanced(cw,cp,MAX,MIN,MAXP,MINP)
                                m.showCurrentVariables()
                                thisView.noTrainTest()
                                currentMenu = 1
                            else:
                                thisView.Error("Valor para cp no valido (debe ser entr 1 - 6)")
                        else:
                            thisView.Error("Valor para cw no valido (debe ser entr 1 - 6)")
                elif opt == 3:
                    #Crear Test/Train
                    percent=thisView.askPercentage()
                    m.generateTrainTest(percent)
                    currentMenu = 3

                elif opt == 4:
                    currentMenu = 0
            else:
                thisView.Error()
        # Menu Clasifición de datos
        if currentMenu == 3:
            opt = thisView.ShowMenuClass()
            if isValid(opt, 'menu'):
                opt = int(opt)
                if opt == 1:
                    # KNN
                    k = thisView.askK()
                    if isValid(k,'k'):
                        m.runClass('KNN',[k])
                    else:
                        thisView.Error("valor de k no valido")
                elif opt == 2:
                    # LDA
                    m.runClass('LDA')
                elif opt == 3:
                    thisKernel = thisView.askKernel()
                    if isValid(thisKernel,'kernel'):
                        cost, tolerance, gamma = thisView.AskSVMValues(thisKernel)
                        if thisKernel == '1': #lineal
                            if isValidFloat(cost):
                                if isValidFloat(tolerance):
                                    m.runClass('SVM',[cost,tolerance,thisKernel])
                                else:
                                    thisView.Error("Valor de Tolerance no valido")
                            else:
                                thisView.Error("Valor de Cost no valido")
                        elif thisKernel == '2': #no lineal
                            if isValid(cost,'costNoLinear'):
                                if isValidFloat(tolerance):
                                    if isValidFloat(gamma):
                                        m.runClass('SVM', [cost, tolerance, thisKernel, gamma])
                                    else:
                                        thisView.Error("Valor de Gamma no valido")
                                else:
                                    thisView.Error("Valor de Tolerance no valido")
                            else:
                                thisView.Error("Valor de Cost no valido")
                    else:
                        thisView.Error("Kernel no valido")
                elif opt == 4:
                    currentMenu = 0
            else:
                thisView.Error()


def isValidFloat(opt):
    try:
        val = float(opt)
        if val >= 0.001 and val <= 2000:
            return True
        else:
            return False
    except ValueError:
        return False

def isValid(opt,type):
    try:
        val = int(opt)
        if type == 'menu':
            if val in range(1,5):
                return True
            else:
                return False
        elif type == 'k':
            if val in range(1,10):
                return True
            else:
                return False
        elif type == 'cw':
            if val in range(1,7):
                return True
            else:
                return False
        elif type == 'kernel':
            if val in (1,2):
                return True
            else:
                return False
        elif type == 'costNoLinear':
            if val in range(1,201):
                return True
            else:
                return False		


    except ValueError:
        return False

def isRangeValid(opt1,opt2):
    try:
        Min = float(opt1)
        Max = float(opt2)
        if Min>0 and Min <Max and Max<100:
            return True
        else:
            return False
    except ValueError:
        return False


main()

