#Recibe por parametro el porcentaje que sera Training
#Ej: si recibe 8, sera 80%-20%

myArgs <- commandArgs(trailingOnly = TRUE)
thisNum = as.numeric(myArgs)


if(!require(caret)) install.packages("caret",repos = "http://cran.us.r-project.org", dependencies=TRUE)
if(!require(lattice)) install.packages("lattice",repos = "http://cran.us.r-project.org", dependencies=TRUE)

#Functions
makeDF<-function(autor,party){  
    #mycols<-ncol(autor)
    myrows<-nrow(autor)
 
    DF<-data.frame(Party=c(rep(party,myrows)))      
    #autor[is.na(autor)] <- 0 #set nulls to 0
    return(cbind(DF,autor))    
}



#devuelve lista con las columnas que estan a 0
ColsZero<-function(Data){
    x<-NULL
    cont<-0
    for (i in (2:ncol(Data))){
        a=sum(Data[,i])
        if (a==0){   
            x[cont] = i
            cont=cont+1
        }
    }     
    return(x)
}

CleanAndNorm<-function(df){
    df[is.na(df)] <- 0  #paso Nulls a 0 si los hubiese
    dfm<-data.matrix(df)
    x<-nrow(dfm)
    cont<-0 #contador de lineas borradas
    for (i in x:1){
        s<-sum(dfm[i,])
        if (s<=0){
			dfm<-dfm[-i,]
            cont<-cont+1
            
        #}else{
			#normalizacion
			#dfm[i,]<-dfm[i,]/s
            #dfm[i,]<-round(dfm[i,]/s,6)
        }
    }
 
    dfm<-data.frame(dfm)
    #print(cont*100/x)
    return(dfm)    
}


getRowIndex<-function(autor){  
    set.seed(100)	
    thisNum <-thisNum /10  
    return(sample(1:nrow(autor), thisNum*nrow(autor)))    
}


##############################

#Lectura de datos de los archivos 
PP<-read.csv("data/PP.csv")
Cs<-read.csv("data/Cs.csv")
PSOE<-read.csv("data/PSOE.csv")
ERC<-read.csv("data/ERC.csv")
jxcat<-read.csv("data/jxcat.csv")
pod<-read.csv("data/pod.csv")

#Limpieza de filas vacias y normalizacin
PP<-CleanAndNorm(PP)
Cs<-CleanAndNorm(Cs)
PSOE<-CleanAndNorm(PSOE)
ERC<-CleanAndNorm(ERC)
jxcat<-CleanAndNorm(jxcat)
pod<-CleanAndNorm(pod)

#Asignacion de Etiquetas
PP<-makeDF(PP,"PP")
Cs<-makeDF(Cs,"Cs")
PSOE<-makeDF(PSOE,"PSOE")
ERC<-makeDF(ERC,"ERC")
jxcat<-makeDF(jxcat,"jxcat")
pod<-makeDF(pod,"pod")

fullData<-rbind(PP,Cs,PSOE,ERC,jxcat,pod)

# Creacion de Training y Test data 
#PP
RowIndex <-getRowIndex(PP)
trainingData <- PP[RowIndex, ] 
testData  <- PP[-RowIndex, ]  
fullTrain<-trainingData
fullTest<-testData

#Cs
RowIndex <-getRowIndex(Cs)
trainingData <- Cs[RowIndex, ] 
testData  <- Cs[-RowIndex, ]
fullTrain<-rbind(fullTrain,trainingData)
fullTest<-rbind(fullTest,testData)

#PSOE
RowIndex <-getRowIndex(PSOE)
trainingData <- PSOE[RowIndex, ] 
testData  <- PSOE[-RowIndex, ]
fullTrain<-rbind(fullTrain,trainingData)
fullTest<-rbind(fullTest,testData)

#ERC
RowIndex <-getRowIndex(ERC)
trainingData <- ERC[RowIndex, ] 
testData  <- ERC[-RowIndex, ]
fullTrain<-rbind(fullTrain,trainingData)
fullTest<-rbind(fullTest,testData)

#jxcat
RowIndex <-getRowIndex(jxcat)
trainingData <- jxcat[RowIndex, ] 
testData  <- jxcat[-RowIndex, ]
fullTrain<-rbind(fullTrain,trainingData)
fullTest<-rbind(fullTest,testData)

#pod
RowIndex <-getRowIndex(pod)
trainingData <- pod[RowIndex, ] 
testData  <- pod[-RowIndex, ]
fullTrain<-rbind(fullTrain,trainingData)
fullTest<-rbind(fullTest,testData)

YfullTrain<-fullTrain[,1]
XfullTrain<-fullTrain[,-1]
#XfullTrain<-getRowIndex(XfullTrain) #datos normalizados

YfullTest<-fullTest[,1]
XfullTest<-fullTest[,-1]
#XfullTest<-normalize(XfullTest)


fullData<-rbind(PP,Cs,PSOE,ERC,jxcat,pod)
#dim(fullTrain)
#dim(fullTest)

colsZero<-ColsZero(fullData) #Creo lista con las columnas que han quedado a 0 y las elimino de Test/Train
if(length(colsZero)>0){
	fullTrain<-subset(fullTrain, select = -colsZero)
	fullTest<-subset(fullTest, select = -colsZero)
}



##




##








save(fullTrain, file = "fullTrain.rda")
save(fullTest, file = "fullTest.rda")

print("FullTrain created")
dim(fullTrain)
print("FullTest created")
dim(fullTest)



