#KNN ALL DATA

myArgs <- commandArgs(trailingOnly = TRUE)
k = as.numeric(myArgs)

if(!require(caret)) install.packages("caret",repos = "http://cran.us.r-project.org", dependencies=TRUE)
library(caret)

load("fullTrain.rda")
load("fullTest.rda")

CleanAndNorm<-function(df){
    df[is.na(df)] <- 0  #paso Nulls a 0 si los hubiese
    dfm<-data.matrix(df)
    x<-nrow(dfm)
    for (i in x:1){
        s<-sum(dfm[i,])
        if (s>0){
			#normalizacion
			#dfm[i,]<-dfm[i,]/s
            dfm[i,]<-round(dfm[i,]/s,4)
		}
    } 
    dfm<-data.frame(dfm)
    #print(cont*100/x)
    return(dfm)    
}

fullTrain[,-1]<-CleanAndNorm(fullTrain[,-1])


y<-fullTest[,1]
x<-CleanAndNorm(fullTest[,-1])
#k<-5
start_time <- Sys.time()

#######
modelknn<-knn3(Party ~ .,data=fullTrain,k=k)
######

#Predict using the model



yhatknn<-predict(modelknn,x,type="class")
end_time <- Sys.time()
end_time-start_time

#Accuracy of the model
knntab<-table(yhatknn,y)
c<-confusionMatrix(knntab)

#Matriz de confusión 
thisConf<-c$table
thisConf
n<-sum(thisConf)
n.good<- sum(diag(thisConf))
n.bad<-n-n.good
prob.err<-n.bad/n
print(paste('Accuracy',round(1-prob.err,4)))
print(paste('Prob Error',round(prob.err,4)))

