#LDA ALL DATA
myArgs <- commandArgs(trailingOnly = TRUE)
myCutoff = as.numeric(myArgs)
#print(paste("cutoff",myCutoff))

if(!require(MASS)) install.packages("MASS",repos = "http://cran.us.r-project.org", dependencies=TRUE)
if(!require(caret)) install.packages("caret",repos = "http://cran.us.r-project.org", dependencies=TRUE)
if(!require(lattice)) install.packages("lattice",repos = "http://cran.us.r-project.org", dependencies=TRUE)
if(!require(ggplot2)) install.packages("ggplot2",repos = "http://cran.us.r-project.org", dependencies=TRUE)

require(MASS)
library(caret)
require(lattice)
require(ggplot2)

options(warn=-1)

load("fullTrain.rda")
load("fullTest.rda")

#Analisis de los datos
myDataTrain<-fullTrain
myDataTest<-fullTest

start_time <- Sys.time()

#Eliminacion de las variables con Desviacion Standard = 0
SDisZ<-sapply(myDataTrain[,-1], function(x) { sd(x) == 0} )
if (length(SDisZ)>0){
    SDisZ<-names(SDisZ[SDisZ==TRUE])
    removeSD<-NULL
    for (i in 1:length(SDisZ)){
        removeSD<-c(removeSD,which(colnames(myDataTrain)==SDisZ[i]))
        }
    }
#print(paste("removeSD",removeSD))

#Busco variables con correlacin para eliminarlas
#elimino de la busqueda las variables ya elimindas por SD=0 (y "Party")
rrr<-c(1,removeSD)
thisCorrelation<-cor(myDataTrain[,-rrr])

thisCorrelation[is.na(thisCorrelation)]=0
#myCutoff<-0.9
indexesToDrop <- findCorrelation(thisCorrelation, cutoff = myCutoff)

badV<-NULL
badV<-c(removeSD,indexesToDrop+1) #sumo 1 a indexesToDrop para que tenga en cuenta que hay la variable predictora Party en posicion 1


if (length(badV)>0){
	myDataTrain<-myDataTrain[,-badV]
	myDataTest<-myDataTest[,-badV]
	#print(paste("Variables finales:",ncol(myDataTrain)))
}
#start_time <- Sys.time()

model.lda<-lda(Party~.,data=myDataTrain)
model.lda.p<-predict(model.lda,newdata=myDataTest,type='response')

end_time <- Sys.time()
print(end_time-start_time)

model.lda.conf<-table("True"=myDataTest$Party,"Pred"=model.lda.p$class)

#Matriz de confusin 
thisConf<-model.lda.conf
thisConf
n<-sum(thisConf)
n.good<- sum(diag(thisConf))
n.bad<-n-n.good
prob.err<-n.bad/n
print(paste('Accuracy',round(1-prob.err,4)))
print(paste('Prob Error',round(prob.err,4)))

