#!/usr/bin/env python
# encoding: utf-8
import csv
import numpy as np
import nltk
import pickle
from nltk.stem.porter import PorterStemmer
import subprocess

class Model(object):
	# Class Attribute
	initMap = {}  # original mapping of the words used
	decrypter = {}
	PairinitMap={}
	Pairdecrypter={}
	usableMap = {}
	timesWordsUsed = []
	timesPairsUsed = []
	twitsMapped = []
	cont = 0
	Paircont=0
	returnData=[]
	thisInfo=[]
	contTweetsParty=0    

	MAXWORDLENGTH=16
	MINWORDLENGTH=2

	autors = ["albiol", "pablocasado", "marianorajoy", "Rivera", "InesArrimadas", "carrizosacarlos", "sanchezcastejon",
			  "miqueliceta", "martarovira", "junqueras", "gabrielrufian", "KRLS", "QuimTorra", "artadi", "iglesias",
			  "pnique", "Irene_Montero_"]

	uselessWords =["http",'"',"''",'%','``','//www','’', '”',"…","???","????","?","@","#","'",'--','thread','000','//m','//ow', "!","(",")",";",":","account", 'html','‘', 'utm_medium=twitt','id_externo_rsoc=tw_cc','//','//twitter','utm_source=twitt']



	# Inicialización
	def __init__(self,cw=4,cp=4,MAX=5,MIN = 0.5,MAXP = 50,MINP = 0.5):
		# porcentajes de uso de palabra
		self.MAX = MAX
		self.MIN = MIN
		self.MAXP = MAXP
		self.MINP = MINP
		#cantidad de partidos que las usan, como maximo
		self.cw = cw
		self.cp = cp
		#porcentaje de entrenamiento (sobre 10)
		self.trainPercent='8'

	


	def mapperAdvanced(self,cw=4,cp=4,MAX=5,MIN = 0.5,MAXP = 50,MINP = 0.5):
		self.resetGlobals()
		self.MAX = MAX
		self.MIN = MIN
		self.MAXP = MAXP
		self.MINP = MINP
		self.cw = cw
		self.cp = cp
	

		self.usableMapCreator(self.autors, self.cw,self.cp)
		self.mapAllTweets(self.autors)
		self.thisInfo = [MAX, MIN, MAXP, MINP, cw, cp,len(self.usableMap)]

		self.saveDetails()

	def showCurrentVariables(self):
		print("Variables creadas:" +str(len(self.usableMap)))


	def generateTrainTest(self,trainPercent='8'):

		x=self.runScript('DataCollector',[trainPercent]) #Recibe la información de generar el Train/test 
	
		self.getRowColData(x)  # Guarda la cantidad de datos que hay en Train/test y el numero de variables
		self.trainPercent = trainPercent
		if len(self.thisInfo)==11:
			self.thisInfo[7] = self.trainPercent
			self.thisInfo[8] = self.testSize
			self.thisInfo[9] = self.trainSize
			self.thisInfo[10]= self.nValues
		elif len(self.thisInfo)==7:
			self.thisInfo.append(trainPercent)
			self.thisInfo.append(self.testSize)
			self.thisInfo.append(self.trainSize)
			self.thisInfo.append(self.nValues)
		self.saveDetails()
		self.showDataDetails()


	def loadDatafromfile(self):
		self.loadTwitMaps()
		print(".Mapa Cargado")
		print("..Mapeando Tweets")
		self.mapAllTweets(self.autors)
		self.resetGlobals()
		print("...Creando Train / test")
		x= self.runScript('DataCollector', [self.trainPercent])
		self.getRowColData(x)
		self.showDataDetails()


	def loadDetails(self):
		ready=False
		try:
			f = open('DataDetails.pckl', 'rb')
			ready=True
		except FileNotFoundError:
			return False

		if ready:
			self.thisInfo = pickle.load(f)
			f.close()
			if len(self.thisInfo) >= 7:

				self.MAX = self.thisInfo[0]
				self.MIN = self.thisInfo[1]
				self.MAXP = self.thisInfo[2]
				self.MINP = self.thisInfo[3]
				self.cw = self.thisInfo[4]
				self.cp = self.thisInfo[5]
				self.lenUsableMap= self.thisInfo[6]
				if len(self.thisInfo) == 11:
					self.trainPercent = self.thisInfo[7]
					self.testSize = self.thisInfo[8]
					self.trainSize = self.thisInfo[9]
					self.nValues = self.thisInfo[10]

				return True



	def saveDetails(self):
		f = open('DataDetails.pckl', 'wb')
		pickle.dump(self.thisInfo, f)
		f.close()


	def showDataDetails(self):
		# Comprueba si hay datos guardados en disco y muestra los datos
		try:
			w=self.loadDetails()
			#f = open('DataDetails.pckl', 'r')
		except FileNotFoundError:
			print("No se puede mostrar, no se han creado datos codificados")


		if w:
			print("\n MIN:"+ str(self.MIN)+ ", MAX:"+ str(self.MAX)+ ", MINP:"+ str(self.MINP)+ ", MAXP:"+ str( self.MAXP))
			print("Max num partidos que han usado esa palabra: "+ str(self.cw))
			print("Max num partidos que han usado esa pareja: "+str(self.cp))
			print("Numero de variables generadas: "+str(self.lenUsableMap))

			try:
				fh = open('fullTrain.rda', 'r')
				print("Train ("+str( self.trainSize)+ " lineas)"+ str(int(self.trainPercent) * 10)+ "%")
				print("Test ("+str( self.testSize)+" lineas)"+str((10 - int(self.trainPercent)) * 10)+ "% ")
				print("Numero de variables finales: " + str(  self.nValues)+"\n")

			except FileNotFoundError:
				print("No se ha creado Train / Test")
		else:
			print("No se pueden mostrar, no se han  generado datos")





	def getRowColData(self,x):
		linea = x
		linea = linea.replace('"', '')
		linea = linea.replace('[1]', '')
		linea = linea.replace('\n', '')
		linea = linea.split(" ")
		#print(linea)
		linea=[d for d in linea if d != '']

		self.testSize=int(linea[6])
		self.trainSize=int(linea[2])
		self.nValues = int(linea[3])


	def runClass(self,method,arg=None):
		if arg==None:

			x=self.runScript(method)
		else:
			x = self.runScript(method,arg)
		print(x)





	def runScript(self,name,args= None):
		# Define commando and argumentos
		command = 'Rscript'
		path2script = name + ".R"

		# Crea el comando del subproceso
		if (args!= None):
			cmd = [command, path2script] + args
		else:
			cmd = [command, path2script]

		#recibe la información devuelta por el script
		x = subprocess.check_output(cmd, universal_newlines=True)
		return (x)

	def resetGlobals(self):
		self.initMap = {}  # mapeo original de las palabras
		self.decrypter = {}
		self.PairinitMap = {}
		self.Pairdecrypter = {}
		self.usableMap = {}
		self.timesWordsUsed = []
		self.timesPairsUsed = []
		self.twitsMapped = []




	def usableMapCreator(self,autors,cw,cp):
		#crea el diccionario de palabras buenas teniendo en cuenta que se hayan usado un % dentro de los limites
		# y sean usadas por como maximo una cantidad determinada de partidos.
		# cw y cp son la cantidad de partidos que tienen que usar (como maximo) esa palabra/par, para que se considere buena

		# 0)2 PP, 1)5 Cs, 2)7 PSOE, 3)10 erc, 4)13 jxcat,5)16 pod

		myW=[] #Variables donde guardare todas las palabras y todas las parejas usadas con frecuencia dentro de Min/Max
		myP=[]
		self.contTweetsParty = 0
		for i in range(0,len(autors)):
			self.fillinitMap(self.getTweetsListed(autors[i]))#Cracion del diccionario initMap
			if i==2:
				w,p=self.findMostUsed("PP")
				myW.append(w)
				myP.append(p)
				self.contTweetsParty = 0
			if i==5:
				w,p=self.findMostUsed("CS")
				myW.append(w)
				myP.append(p)
				self.contTweetsParty = 0
			if i==7:
				w,p=self.findMostUsed("PSOE")
				myW.append(w)
				myP.append(p)
				self.contTweetsParty = 0
			if i==10:
				w,p=self.findMostUsed("ERC")
				myW.append(w)
				myP.append(p)
				self.contTweetsParty = 0
			if i==13:
				w,p=self.findMostUsed("jxcat")
				myW.append(w)
				myP.append(p)
				self.contTweetsParty = 0
			if i==16:
				w,p=self.findMostUsed("pod")
				myW.append(w)
				myP.append(p)
				self.contTweetsParty = 0

		#Crea lista de con todas las palabras usadas siempre que algun partido las haya usado un porcentaje de veces entre min y max
		allWords = [word[1] for x in myW for word in x]
		allWords = list(set(allWords))

		# Crea lista de con todas las parejas de palabras usadas siempre que algun partido las haya usado un porcentaje de veces entre minp y maxp
		allPairs = [pair[1] for x in myP for pair in x]
		allPairs = list(set(allPairs))



		decrypter={} #reutilizare el desencriptador para el diccioario final usableMap

		#Crea/añade al nuevo diccionario (usableMap las palabras/pares que usara para codificar los tweets
		self.CreateGoodWords(allWords, myW,self.cw)
		self.CreateGoodWords(allPairs, myP,self.cp)

		# una vez creado mis diccionarios los guardo
		self.saveTwitMap(self.usableMap, "usableMap")
		self.saveTwitMap(self.decrypter, "decrypter")

	#Crea los archivos para cada partido
	def mapAllTweets(self,autors):
		twitsMapped=[] #donde guardare la lista de los tweets codificados 
		for i in range(0, len(autors)):
			autorTweets= self.getTweetsListed(autors[i])
			twitsMapped += self.mapMyTweets(autorTweets)
		
			if i==2:
				self.saveEncodedTweets(twitsMapped, 'PP')
				twitsMapped=[]
				
			if i==5:
				self.saveEncodedTweets(twitsMapped, 'Cs')
				twitsMapped=[]
				
			if i==7:
				self.saveEncodedTweets(twitsMapped, 'PSOE')
				twitsMapped=[]
				
			if i==10:
				self.saveEncodedTweets(twitsMapped, 'ERC')
				twitsMapped=[]
				
			if i==13:
				self.saveEncodedTweets(twitsMapped, 'jxcat')
				twitsMapped=[]
				
			if i==16:
				self.saveEncodedTweets(twitsMapped, 'pod')
				twitsMapped=[]
				

	def fillinitMap(self,listTweets):  # fill the initMap with all the words used to assign a int to each word
		for tweet in listTweets:  # adds the words of the tweets to the initMap dictionary
			self.fillwithTweet(tweet)
			self.fillPairwithTweet(tweet)
			self.contTweetsParty+=1

	def getTweetsListed(self,autor):
		bulkCleanLine = ""
		Ent = open("tweets/" + autor + ".txt", "r")
		for linea in Ent:
			if linea != '':
				prolinea = linea.replace(",", " ")
				for wrd in self.uselessWords:
					prolinea.replace(wrd, "")
				bulkCleanLine += prolinea.replace(".", " ")
		listTweets = bulkCleanLine.split('\n')
		return listTweets

	def fillwithTweet(self,tweet): #Añade las palabras usadas en el tweet al diccionario de palabras,
							  #y actualiza el contador de veces usada esa palabra en la lista
		#global cont, initMap,timesWordsUsed,MAXWORDLENGTH,MINWORDLENGTH
		porter_stemmer = PorterStemmer()
		nltk_tokens = nltk.word_tokenize(tweet.lower(), 'spanish') #Sematiza las palabras
		for w in nltk_tokens:
			SemWord = porter_stemmer.stem(w)
			if len(SemWord) <= self.MAXWORDLENGTH and self.MINWORDLENGTH < len(SemWord) :
				if SemWord not in self.uselessWords:
					if SemWord not in self.initMap:
						self.initMap[SemWord] = self.cont
						self.decrypter[self.cont] = SemWord
						#timeWord=[1,cont]
						self.timesWordsUsed.append(1)
						self.cont += 1
					else:
						self.timesWordsUsed[self.initMap[SemWord]] += 1

	def fillPairwithTweet(self,tweet): #Añade las parejas de palabras usadas en el tweet al diccionario de parejas
							  #y actualiza el contador de veces usada esa pareja en la lista
		#global Paircont, PairinitMap,timesPairsUsed,Pairdecrypter
		x1=""
		x2=""
		porter_stemmer = PorterStemmer()
		nltk_tokens = nltk.word_tokenize(tweet.lower(), 'spanish')
		for w in nltk_tokens:
			word = porter_stemmer.stem(w) # Sematización de palabras
			if x1=="":
				x1=word
			elif x1!=x2:
				x2=word
				pair=str(x1+" "+x2)

				x1=word
				x2=""
				if pair not in self.PairinitMap:
					self.PairinitMap[pair] = self.Paircont
					self.Pairdecrypter[self.Paircont] = pair
					self.timesPairsUsed.append(1)
					self.Paircont += 1
				else:
					self.timesPairsUsed[self.PairinitMap[pair]] += 1

	#Guarda en archivo las palabras/parejas si su porcentaje de uso esta dentro de los limites marcados por MAX /MIN y las devuelve en listas
	def findMostUsed(self,Party):
		#file = open(Party+".txt", "w")
		w = self.mostUsed(self.timesWordsUsed, self.decrypter,self.MAX,self.MIN)   #para testear sin palabras, pongo max a 0

		#file.write(str(w))
		#file.close()

		#file = open(Party+"2.txt", "w") #se imprimen las palabras para mostrar y pruebas
		p = self.mostUsed(self.timesPairsUsed, self.Pairdecrypter,self.MAXP,self.MINP) #para testear sin, pongo max a 0

		#file.write(str(p))
		#file.close()

		self.initMap = {}
		self.decrypter = {}
		self.timesWordsUsed = []
		self.PairinitMap = {}
		self.Pairdecrypter = {}
		self.timesPairsUsed = []
		self.cont = 0
		self.Paircont=0
		return(w,p)

	def mostUsed(self,x,d, max,min): #Retorna listado ordenado descendente de las palabras mas usadas dentro del umbral de % establecido
		#donde x es una lista de la cantidad de veces usada la palabra, y d el diccionario de palabras
		w=[]
		s =self.contTweetsParty
		for indx in range(0,len(x)):
			t=round(x[indx]*100/s,5)
			if max > t and min < t:
				w.append([t,d[indx]])

		w.sort(reverse=True)
		#print("cantidad d palabras totales: ",len(w))
		return (w)

	def CreateGoodWords(self,allWords,myW,cw):
		#global usableMap,decrypter
		# Crea otra lista con las palabras/pares usadas por: criterio de partidos que las usan
		GoodW=[]
		contFounds = 0  # contador de partidos donde ha aparecido la palabra
		indexDict = len(self.usableMap)
		numPar = 0
		numWor = 0
		#print(len(allWords))
		for word in allWords:  #
			# Si es un par de palabras
			if (' ' in word):
				for i in range(0, len(myW)):  # recorro cada lista de tweets
					if self.findWord(word, myW[i]):  # miro si está la pareja en esa lista
						contFounds += 1  # añado 1 a mi contador de encontrados
				#Guardo la palabra si la han usado al menos cw partidos
				if contFounds <=cw:
					GoodW.append(word)  # guardo esa palabra
					self.usableMap[word] = indexDict
					self.decrypter[indexDict] = word
					numPar +=1
				contFounds = 0
				indexDict = len(self.usableMap)



			# Si es una sola palabra
			else:
				for i in range(0, len(myW)):  # recorro cada lista de tweets
					if self.findWord(word, myW[i]):  # miro si está la palabra en esa lista
						contFounds += 1  # añado 1 a mi contador de encontrados
				# Guardo la palabra si cumple ciertos criterios:
				# Si la han usado al menos la mitad de partidos, o solo 1
				#if contFounds >= len(myW) / 2 or contFounds == 1:

				if contFounds <= cw:
					GoodW.append(word)  # Y guardo esa palabra
					self.usableMap[word] = indexDict
					self.decrypter[indexDict] = word
					numWor += 1
				contFounds = 0
				indexDict = len(self.usableMap)

	   # if (numWor != 0):
			#print("total de palabras", numWor)
		#if(numPar!=0):
			#print("total de pares usados", numPar)
			#print("num palabras a codificar", len(usableMap))
		#self.saveListTxt('GoodW', GoodW)

	def findWord(self,word, list):  # busca si una palabra esta en una lista
		for i in list:
			w = i[1]
			if word == str(w):
				return True
		return False

	def mapMyTweets(self,listTweets):
		#global usableMap
		currTweet = [0] * len(self.usableMap)  # inicialización del vector 'hot enconded'
		allTweetsEncoded = [] # inicialización del vector de vectores con todos los tweets de ese partido
		porter_stemmer = PorterStemmer()
		a=''
		for tweet in listTweets:
			nltk_tokens = nltk.word_tokenize(tweet, 'spanish')
			for w in nltk_tokens:
				SemWord = porter_stemmer.stem(w)
				if SemWord in self.usableMap:
					curr=currTweet[self.usableMap[SemWord]]
					currTweet[self.usableMap[SemWord]] = curr + 1  # guardo el peso de haber encontrado la palabra

				#comprobando si las parejas estan
				if a=='':
					a=SemWord
				else:
					pair=str(a+" "+SemWord)
					if pair in self.usableMap:
						curr = currTweet[self.usableMap[pair]]
						currTweet[self.usableMap[pair]] = curr + 3  #considero que hallar una pareja vale el tripe que una palabra ya que son 2 palabras en un orden concreto
					a=SemWord

			allTweetsEncoded.append(currTweet)
			currTweet = [0] * len(self.usableMap)
		return allTweetsEncoded

	#Guarda en archivo, para cada partido los tweets codificados (hot-encoding) con las palabras de 'usableMap'
	def saveEncodedTweets(self,twitsMapped, autor):
		myCols = len(self.usableMap)
		csvfile = "data/" + autor + ".csv"
		cols = []
		for i in range(myCols):
			cols.append('x' + str(i))
		twitsMapped.insert(0, cols)
		with open(csvfile, "w") as output:
			writer = csv.writer(output, lineterminator='\n')
			writer.writerows(twitsMapped)

		
	#Guarda en archivo el diccionario con las palabras buenas (para no tener que calcularlo cada vez)
	def saveTwitMap(self,myMap, name):
		np.save(name + '.npy', myMap)
		#print(name + " saved")
		# with open(myMap + '.pkl', 'wb') as f:
		# pickle.dump(str(myMap), f, pickle.HIGHEST_PROTOCOL)

	#Carga de archivo el diccionario con las palabras buenas
	def loadTwitMaps(self):
		#global decrypter, usableMap
		self.decrypter = np.load('decrypter.npy').item()
		self.usableMap = np.load('usableMap.npy').item()



	# Guarda lista data en archivo 'name.txt' (para mirar resultados de palabras escogidas)
	def saveListTxt(self,name, data):
		name = name + ".txt"
		file = open(name, "w")
		file.write(str(len(data)))
		file.write(str(data))
		file.close()


	def decryptTweet(self,twitMapped):
		twit = [self.decrypter[w] for w in twitMapped if w in self.decrypter]
		print(twit)