#SUPORT VECTOR MACHINE

if(!require(caret)) install.packages("caret",repos = "", dependencies=TRUE)
if(!require(e1071)) install.packages('e1071',repos = "", dependencies=TRUE)

myArgs <- commandArgs(trailingOnly = TRUE)
thisArgs = as.numeric(myArgs) #cost,tol,kernel,gamma



KernelList<-c('linear','radial')

thisCost=thisArgs[1]
tol=thisArgs[2]
thisKernel=KernelList[thisArgs[3]]

if(length(thisArgs)>3){
	g=thisArgs[4]
}

options(warn=-1)



library(Matrix)
library(e1071)

load("fullTrain.rda")
load("fullTest.rda")


#Creacion de la matriz Sparse con los datos de train (excepto la etiqueta)
regMat<-data.matrix(fullTrain[,-1])
trainX <- Matrix(regMat, sparse = TRUE)




start_time <- Sys.time()

if (thisKernel == 'linear'){
	print(paste("SVM Kernel lineal con Cost:",thisCost," Tolerancia:",tol))
	svm.model <- svm(x=trainX, y=fullTrain[,1], cost = thisCost,kernel="linear",tolerance =tol)
}else{
	print(paste("SVM Kernel Base Radial Gausiana con Cost:",thisCost," Gamma:",g,"/num.var Tolerancia:",tol))
	svm.model <- svm(x=trainX, y=fullTrain[,1], cost = thisCost,kernel="radial",tolerance =tol,gamma = g/ncol(fullTest))
}


end_time <- Sys.time()
end_time-start_time

svm.pred <- predict(svm.model, fullTest[,-1])
t<-table(pred = svm.pred, true = fullTest[,1])
t
n<-sum(t)
n.good<- sum(diag(t))
n.bad<-n-n.good
prob.err<-n.bad/n
print(paste('Accuracy',round(1-prob.err,4)))
print(paste('Prob Error',round(prob.err,4)))

